;angular.module('Landers.angular')
    .factory('RouteMenu', ['$state', function($state){
            function RouteMenu( selector ){
                var that = this;

                this.getMenu = function( callback ){
                    var $menu = $(selector);

                    if ( !$menu.length || !$menu.children().length) {
                        var self = arguments.callee;
                        setTimeout(function(){
                            self(callback);
                        }, 300);
                    } else {
                        callback && callback( $menu );
                    }

                    return that;
                };

                this.findForActive = function(callback){
                    var current_state = $state.current.name;
                    var active_states = $state.current.activeStates;
                    if ( !active_states || !active_states.length ) {
                        active_states = [ current_state ];
                    }

                    that.getMenu( function( $menu ){
                        var $current_state = $(), $other_states = $();
                        angular.forEach(active_states, function(state){
                            if ( state === '$$SELF' ) {
                                state = current_state;
                            }
                            var $find = $menu.find("[ui-sref^='" + state + "(']");
                            if ( current_state === state ) {
                                $current_state = $current_state.add($find);
                            } else {
                                $other_states = $other_states.add($find);
                            }
                        });

                        callback && callback(
                            $current_state.add($other_states),
                            $current_state,
                            $other_states
                        );
                    });

                    return that;
                }
            }

            return {
                make: function(selector){
                    return new RouteMenu(selector);
                }
            }
        }]);